/* $Header: /a/helios/home/woodeaton/src/X11R5/mit/server/ddx/dec/pxws/RCS/pxws_io.c,v 1.1 1992/12/05 11:52:57 trq Exp trq $ */
/* $Log: pxws_io.c,v $
 * Revision 1.1  1992/12/05  11:52:57  trq
 * Initial revision
 *
 * Revision 1.4  1992/10/10  08:15:44  trq
 * Use px_info->rb_phys instead of magic number.
 *
 */

#include <stdio.h>

#include "pxws.h"

#include "X.h"
#include "misc.h"
#include "miscstruct.h"

pxInfo *px_info_ptr;
pa_ComAreaPtr rb_cntrl;
pa_Com2dPtr rb_com2d;

int px_info_max_x;
int px_info_max_y;

#define PA_3RD_WORD	8

ga_send_packet()
{
  int nbuf;
  int gaintr;
  int i;
  
  for(i = 0; rb_com2d->intr_status != 0; i++);
  
/*  if(i != 0)
    fprintf(stderr, "Spun on intr_status: %d\n", i);
*/

  nbuf = rb_com2d->lastWritten;
  if(nbuf >= PA_QUEUE_PACKETS)
    {
      ErrorF("Too many packets\n");
      return FALSE;
    }
  if(nbuf != PA_QUEUE_PACKETS-1)
      rb_com2d->lastWritten++;
  else
      rb_com2d->lastWritten = 0;
  
  if(rb_com2d->lastRead == 0)
      rb_com2d->lastRead = PA_QUEUE_PACKETS-1;
  else
      rb_com2d->lastRead--;

  rb_com2d->intr_status |= 1;
	
  gaintr = px_info_ptr->dev.pa.stic_regs->ipdvint;
	
  gaintr |= (STIC_INT_P_EN| STIC_INT_P | STIC_INT_P_WE);
  gaintr &= ~(STIC_INT_E_WE|STIC_INT_V_WE);
	
  px_info_ptr->dev.pa.stic_regs->ipdvint = gaintr;
}

#ifdef __GNUC__
__inline__
#endif
static int aluxtopx(alu)
     int alu;
{
  int retval;
  switch(alu)
    {
    case GXclear:
      retval = UMET_CLEAR;
      break;
    case GXand:
      retval = UMET_AND;
      break;
    case GXandReverse:
      retval = UMET_ANDREVERSE;
      break;
    case GXcopy:
      retval = UMET_COPY;
      break;
    case GXandInverted:
      retval = UMET_ANDINVERTED;
      break;
    case GXnoop:
      retval = UMET_NOOP;
      break;
    case GXxor:
      retval = UMET_XOR;
      break;
    case GXor:
      retval = UMET_OR;
      break;
    case GXnor:
      retval = UMET_NOR;
      break;
    case GXequiv:
      retval = UMET_EQUIV;
      break;
    case GXinvert:
      retval = UMET_INVERT;
      break;
    case GXorReverse:
      retval = UMET_ORREVERSE;
      break;
    case GXcopyInverted:
      retval = UMET_COPYINVERTED;
      break;
    case GXorInverted:
      retval = UMET_ORINVERTED;
      break;
    case GXnand:
      retval = UMET_NAND;
      break;
    case GXset:
      retval = UMET_SET;
      break;
    default:
      fprintf(stderr, "unhandled alu\n");
      retval = UMET_COPY;
    }
  return retval;
}
  
pxpmax1Line(x1, y1, x2, y2, pixel, alu, planemask)
     int x1, y1, x2, y2;
     unsigned long pixel;
     int alu;
     int planemask;
{
  int *nbuf_addr;
  int nbuf;

  nbuf = rb_com2d->lastWritten;
  if(nbuf >= PA_QUEUE_PACKETS)
    {
      ErrorF("Too many packets\n");
      return FALSE;
    }
  nbuf_addr = &(rb_cntrl->IntrBuf[nbuf][0]);
  nbuf_addr[0] = 5;
  nbuf_addr[1] = 10;
  nbuf_addr[2] = PA_3RD_WORD;
  nbuf_addr[3] = STAMP_CMD_LINES | RGB_CONST | LW_PERPKT | CLIPRECT;
  planemask &= 0xff;
  nbuf_addr[4] = (1 << 24) | (planemask << 16) | (planemask << 8) | planemask;
  nbuf_addr[5] = 0;
  nbuf_addr[6] = aluxtopx(alu);
  nbuf_addr[6] |= UPD_ENABLE | WE_CLIPRECT;
  nbuf_addr[7] = 4;
  nbuf_addr[8] = 0x7c00400;
  nbuf_addr[9] = 0x7ffffff;
  nbuf_addr[10] = pixel;
  nbuf_addr[11] = (x1 << 19) | (y1 << 3);
  nbuf_addr[12] = (x2 << 19) | (y2 << 3);
  
  ga_send_packet();
}  

static int line_count;
static int *line_addr;

pxpmaxStartLines(pixel, alu, planemask)
     unsigned long pixel;
     int alu;
     int planemask;
{
  int nbuf;

  nbuf = rb_com2d->lastWritten;
  if(nbuf >= PA_QUEUE_PACKETS)
    {
      ErrorF("Too many packets\n");
      return FALSE;
    }
  line_addr = &(rb_cntrl->IntrBuf[nbuf][0]);
  line_addr[0] = 5;
  line_addr[2] = PA_3RD_WORD;
  line_addr[3] = STAMP_CMD_LINES | RGB_CONST | LW_PERPKT | CLIPRECT;
  planemask &= 0xff;
  line_addr[4] = (planemask << 16) | (planemask << 8) | planemask;
  line_addr[5] = 0;
  line_addr[6] = aluxtopx(alu);
  line_addr[6] |= UPD_ENABLE | WE_CLIPRECT;
  line_addr[7] = 4;
  line_addr[8] = 0x7c00400;
  line_addr[9] = 0x7ffffff;
  line_addr[10] = pixel;
  line_count = 0;
}  

pxpmaxAddLine(x1, y1, x2, y2)
     int x1, y1, x2, y2;
{
  line_addr[11+line_count*2] = (x1 << 19) | (y1 << 3);
  line_addr[12+line_count*2] = (x2 << 19) | (y2 << 3);
  line_count++;
  
  if(line_count >= STAMP_MAX_CMDS)
    {
      int planemask, pixel, alu;
      int nbuf;
      
      planemask = line_addr[4];
      alu = line_addr[6];
      pixel = line_addr[10];
      line_addr[1] = 8 + line_count*2;
      line_addr[4] |= (line_count << 24);
      
      ga_send_packet();

      nbuf = rb_com2d->lastWritten;
      if(nbuf >= PA_QUEUE_PACKETS)
	{
	  ErrorF("Too many packets\n");
	  return FALSE;
	}
      line_addr = &(rb_cntrl->IntrBuf[nbuf][0]);
      line_addr[0] = 5;
      line_addr[2] = PA_3RD_WORD;
      line_addr[3] = STAMP_CMD_LINES | RGB_CONST | LW_PERPKT | CLIPRECT;
      line_addr[4] = planemask;
      line_addr[5] = 0;
      line_addr[6] = alu;
      line_addr[7] = 4;
      line_addr[8] = 0x7c00400;
      line_addr[9] = 0x7ffffff;
      line_addr[10] = pixel;
      line_count = 0;
    }  
}  

pxpmaxFinishLines()
{
  if(line_count > 0)
    {
      line_addr[1] = 8 + line_count*2;
      line_addr[4] |= (line_count << 24);
      
      ga_send_packet();
    }
}

pxpmaxWideLine(pBox, pixel, alu, planemask)
     BoxPtr pBox;
     unsigned long pixel;
     int alu;
     int planemask;
{
  int *nbuf_addr;
  int nbuf;
  int y2m;

  nbuf = rb_com2d->lastWritten;
  if(nbuf >= PA_QUEUE_PACKETS)
    {
      ErrorF("Too many packets\n");
      return FALSE;
    }
  
  y2m = pBox->y2 - 1;
  nbuf_addr = &(rb_cntrl->IntrBuf[nbuf][0]);
  nbuf_addr[0] = 5;
  nbuf_addr[1] = 8;
  nbuf_addr[2] = PA_3RD_WORD;
  nbuf_addr[3] = STAMP_CMD_LINES | RGB_CONST | LW_PERPRIM;
  planemask &= 0xff;
  nbuf_addr[4] = (1 << 24) | (planemask << 16) | (planemask << 8) | planemask;
  nbuf_addr[5] = 0;
  nbuf_addr[6] = aluxtopx(alu);
  nbuf_addr[6] |= UPD_ENABLE;
  nbuf_addr[7] = pixel;
  nbuf_addr[8] = ((int)pBox->x1) << 19 | ((y2m + pBox->y1) << 2) | 0x3;
  nbuf_addr[9] = ((pBox->x2-1) << 19) | 0x70000
                 | ((y2m + pBox->y1) << 2) | 0x3;
  nbuf_addr[10] = ((y2m - pBox->y1) << 2) | 0x3;
  
  ga_send_packet();
}

static int bufno = 1;
#define GA_SPBUFSIZE (PAGE + HALF_PAGE)

/* Put a single span */
void
pxpmaxPutSpan(y, xOrigin, xStart, xEnd, psrc, alu, planemask)
     int y;
     int xOrigin;
     int xStart;
     int xEnd;
     int *psrc;
     int alu;
     int planemask;
{
  int *nbuf_addr;
  int nbuf;
  int i;
  int image_off, span_len;

  span_len = xEnd - xStart;
  if((span_len >= GA_SPBUFSIZE) || (span_len < 0))
    {
      ErrorF("Span too large or negative\n");
      return;
    }
  if((xStart < 0) || (y < 0) || (xEnd > px_info_max_x) || (y >=
     px_info_max_y))
    {
      ErrorF("PutSpan: bad region\n");
      return;
    }
  
  bufno ^= 1;			/* switch image areas */
  
				/* put the source into the image */
				/* buffer.  Note there is an offset of */
				/* 12 bytes (3 words) */
  for(i = 0; i < span_len; i++)
    {
      rb_cntrl->image_buf[((bufno*GA_SPBUFSIZE)>>2) + 3 + i]
	= ((char *)psrc)[xOrigin+i];
    }

  image_off = bufno*GA_SPBUFSIZE + PA_IMAGE_BUFFER_OFF;

  nbuf = rb_com2d->lastWritten;
  if(nbuf >= PA_QUEUE_PACKETS)
    {
      ErrorF("Too many packets\n");
      return;
    }
  
  nbuf_addr = &(rb_cntrl->IntrBuf[nbuf][0]);
  nbuf_addr[0] = 5;
  nbuf_addr[1] = 8;
  nbuf_addr[2] = PA_3RD_WORD;
  nbuf_addr[3] = STAMP_CMD_WRITESPANS;
  planemask &= 0xff;
  nbuf_addr[4] = (1 << 24) | (planemask << 16) | (planemask << 8) | planemask;
  nbuf_addr[5] = 0;
  nbuf_addr[6] = aluxtopx(alu);
  nbuf_addr[6] |= UPD_ENABLE | SPAN_MASK;
  nbuf_addr[7] = px_info_ptr->rb_phys | image_off;
  nbuf_addr[8] = 2*span_len*sizeof(int);
  nbuf_addr[9] = xStart << 19 | (y << 3);
  nbuf_addr[10] = 0x0;
  
  ga_send_packet();
}

/* put several spans */
void
pxpmaxPutBox(yStart, yEnd, xOrigin, xStart, xEnd, psrc, psrcWidth,
	     alu, planemask)
     int yStart;
     int yEnd;
     int xOrigin;
     int xStart;
     int xEnd;
     int *psrc;
     int psrcWidth;
     int alu;
     int planemask;
{
  int *nbuf_addr;
  int nbuf;
  int i;
  int image_off, span_len;
  int y;
  int ncom, span_off, tot_span_len;

  span_len = xEnd - xStart;
  if((span_len >= GA_SPBUFSIZE) || (span_len < 0))
    {
      ErrorF("Span too large or negative\n");
      return;
    }
  if((xStart < 0) || (yStart < 0) || (xEnd > px_info_max_x)
     || (yEnd > px_info_max_y))
    {
      ErrorF("PutSpan: bad region\n");
      return;
    }
  
  bufno ^= 1;
  
  nbuf = rb_com2d->lastWritten;
  if(nbuf >= PA_QUEUE_PACKETS)
    {
      ErrorF("Too many packets\n");
      return;
    }
  ncom = 0;
  nbuf_addr = &(rb_cntrl->IntrBuf[nbuf][0]);
				/* index into image buffer.  Note */
				/* extra offset of 12 bytes (3 words) */
				/* to get things aligned */
  span_off = ((bufno*GA_SPBUFSIZE)>>2) + 3;
  tot_span_len = 0;
  image_off = bufno*GA_SPBUFSIZE + PA_IMAGE_BUFFER_OFF;
  for(y = yStart; y < yEnd; y++, psrc += psrcWidth)
    {
      for(i = 0; i < span_len; i++)
	rb_cntrl->image_buf[span_off+i] = ((char *)psrc)[xOrigin+i];
      nbuf_addr[7+ncom*4] = px_info_ptr->rb_phys | (image_off + ncom*4*span_len);
      nbuf_addr[8+ncom*4] = 2*span_len*sizeof(int);
      nbuf_addr[9+ncom*4] = xStart << 19 | (y << 3);
      nbuf_addr[10+ncom*4] = 0x0;
      ncom++;
      span_off += span_len;
      tot_span_len += span_len;
      if(y == yEnd - 1 || ncom >= STAMP_MAX_CMDS-1
	 || tot_span_len + span_len >= GA_SPBUFSIZE>>2)
	{
	  nbuf_addr = &(rb_cntrl->IntrBuf[nbuf][0]);
	  nbuf_addr[0] = 5;
	  nbuf_addr[1] = 4 + ncom*4;
	  nbuf_addr[2] = PA_3RD_WORD;
	  nbuf_addr[3] = STAMP_CMD_WRITESPANS;
	  planemask &= 0xff;
	  nbuf_addr[4] = (ncom << 24) | (planemask << 16)
	    | (planemask << 8) | planemask;
	  nbuf_addr[5] = 0;
	  nbuf_addr[6] = aluxtopx(alu);
	  nbuf_addr[6] |= UPD_ENABLE | SPAN_MASK;
	  ga_send_packet();

	  if(y != yEnd - 1)	/* setup next packet */
	    {
	      bufno ^= 1;
	      nbuf = rb_com2d->lastWritten;
	      if(nbuf >= PA_QUEUE_PACKETS)
		{
		  ErrorF("Too many packets\n");
		  return;
		}
	      ncom = 0;
	      nbuf_addr = &(rb_cntrl->IntrBuf[nbuf][0]);
	      span_off = ((bufno*GA_SPBUFSIZE)>>2) + 3;
	      tot_span_len = 0;
	      image_off = bufno*GA_SPBUFSIZE + PA_IMAGE_BUFFER_OFF;
	    }
	}
    }
}

void
pxpmaxGetSpan(y, xOrigin, xStart, xEnd, psrc, planemask)
     int y;
     int xOrigin;
     int xStart;
     int xEnd;
     int *psrc;
     int planemask;
{
  int *nbuf_addr;
  int nbuf;
  int i;
  int image_off, span_len;

  span_len = xEnd - xStart;
  if((span_len >= GA_SPBUFSIZE) || (span_len < 0))
    {
      ErrorF("Span too large or negative\n");
      return;
    }
  if((xStart < 0) || (y < 0) || (xEnd > px_info_max_x) || (y >=
     px_info_max_y))
    {
      ErrorF("GetSpan: bad region\n");
      return;
    }
  
  bufno ^= 1;
  
  image_off = bufno*GA_SPBUFSIZE + PA_IMAGE_BUFFER_OFF;

  nbuf = rb_com2d->lastWritten;
  if(nbuf >= PA_QUEUE_PACKETS)
    {
      ErrorF("Too many packets\n");
      return;
    }
  
  nbuf_addr = &(rb_cntrl->IntrBuf[nbuf][0]);
  nbuf_addr[0] = 5;
  nbuf_addr[1] = 8;
  nbuf_addr[2] = PA_3RD_WORD;
  nbuf_addr[3] = STAMP_CMD_READSPANS;
/* is this right? */
  planemask = 0xff;
  nbuf_addr[4] = (1 << 24) | (planemask << 16) | (planemask << 8) | planemask;
  nbuf_addr[5] = 0;
  nbuf_addr[6] = UMET_NOOP | UPD_ENABLE | SPAN_MASK;
  nbuf_addr[7] = 0x40000000 | px_info_ptr->rb_phys | image_off;
  nbuf_addr[8] = 2*span_len*sizeof(int);
  nbuf_addr[9] = xStart << 19 | (y << 3);
  nbuf_addr[10] = 0x0;
  
  ga_send_packet();

/* wait for command to complete */
  for(i = 0; rb_com2d->intr_status != 0; i++);

  for(i = 0; i < span_len; i++)
    {
      ((unsigned char *)psrc)[xOrigin+i]
	= (rb_cntrl->image_buf[((bufno*GA_SPBUFSIZE)>>2) + 3 + i] & 0xff);
    }
}

void
pxpmaxCopySpan(ysrc, ydst, xOrigin, xStart, xEnd, alu, planemask)
     int ysrc;
     int ydst;
     int xOrigin;
     int xStart;
     int xEnd;
     int alu;
     int planemask;
{
  int *nbuf_addr;
  int nbuf;
  int i;
  int image_off, span_len;

  span_len = xEnd - xStart;
  if(xOrigin <= xStart)
    span_len--;

  if((span_len >= GA_SPBUFSIZE) || (span_len < 0))
    {
      ErrorF("Span too large or negative\n");
      return;
    }
  if((xStart < 0) || (ysrc < 0) || (ydst < 0) || (xEnd > px_info_max_x)
     || (ysrc >= px_info_max_y) || (ydst >= px_info_max_y))
    {
      ErrorF("CopySpan: bad region\n");
      return;
    }
  
  nbuf = rb_com2d->lastWritten;
  if(nbuf >= PA_QUEUE_PACKETS)
    {
      ErrorF("Too many packets\n");
      return;
    }
  
  nbuf_addr = &(rb_cntrl->IntrBuf[nbuf][0]);
  nbuf_addr[0] = 5;
  nbuf_addr[1] = 11;
  nbuf_addr[2] = PA_3RD_WORD;
  nbuf_addr[3] = STAMP_CMD_COPYSPANS | LW_PERPKT | CLIPRECT;
  planemask &= 0xff;
  nbuf_addr[4] = (1 << 24) | (planemask << 16) | (planemask << 8) | planemask;
  nbuf_addr[5] = 0;
  nbuf_addr[6] = aluxtopx(alu);
  nbuf_addr[6] |= UPD_ENABLE | WE_CLIPRECT | SPAN_MASK;
  if(xStart == xOrigin)
    nbuf_addr[6] |= COPYSPAN_ALIGNED;
  nbuf_addr[7] = 3;
  nbuf_addr[8] = 0x7c00400;
  nbuf_addr[9] = 0x7ffffff;
  nbuf_addr[10] = span_len << 3;
  nbuf_addr[11] = xOrigin << 19 | (ysrc << 3);
  nbuf_addr[12] = xStart << 19 | (ydst << 3);
  nbuf_addr[13] = span_len << 3;

  ga_send_packet();
}

void
pxpmaxSlowCopySpan(ysrc, ydst, xOrigin, xStart, xEnd, alu, planemask)
     int ysrc;
     int ydst;
     int xOrigin;
     int xStart;
     int xEnd;
     int alu;
     int planemask;
{
  int *nbuf_addr;
  int nbuf;
  int i;
  int image_off, span_len;

  span_len = xEnd - xStart;
  if((span_len >= GA_SPBUFSIZE) || (span_len < 0))
    {
      ErrorF("Span too large or negative\n");
      return;
    }
  if((xStart < 0) || (ysrc < 0) || (ydst < 0) || (xEnd > px_info_max_x)
     || (ysrc >= px_info_max_y) || (ydst >= px_info_max_y))
    {
      ErrorF("SlowCopySpan: bad region\n");
      return;
    }
  
  bufno ^= 1;
  
  image_off = bufno*GA_SPBUFSIZE + PA_IMAGE_BUFFER_OFF - 12;

  nbuf = rb_com2d->lastWritten;
  if(nbuf >= PA_QUEUE_PACKETS)
    {
      ErrorF("Too many packets\n");
      return;
    }
  
  nbuf_addr = &(rb_cntrl->IntrBuf[nbuf][0]);
  nbuf_addr[0] = 5;
  nbuf_addr[1] = 8;
  nbuf_addr[2] = PA_3RD_WORD;
  nbuf_addr[3] = STAMP_CMD_READSPANS;
  nbuf_addr[4] = (1 << 24) | 0xffffff;
  nbuf_addr[5] = 0;
  nbuf_addr[6] = UMET_NOOP | UPD_ENABLE | SPAN_MASK;
  nbuf_addr[7] = 0x40000000 | px_info_ptr->rb_phys | image_off;
  nbuf_addr[8] = 2*span_len*sizeof(int);
  nbuf_addr[9] = xOrigin << 19 | (ysrc << 3);
  nbuf_addr[10] = 0x0;
  
  ga_send_packet();

  nbuf = rb_com2d->lastWritten;
  if(nbuf >= PA_QUEUE_PACKETS)
    {
      ErrorF("Too many packets\n");
      return;
    }
  
  nbuf_addr = &(rb_cntrl->IntrBuf[nbuf][0]);
  nbuf_addr[0] = 5;
  nbuf_addr[1] = 8;
  nbuf_addr[2] = PA_3RD_WORD;
  nbuf_addr[3] = STAMP_CMD_WRITESPANS;
  planemask &= 0xff;
  nbuf_addr[4] = (1 << 24) | (planemask << 16) | (planemask << 8) | planemask;
  nbuf_addr[5] = 0;
  nbuf_addr[6] = aluxtopx(alu);
  nbuf_addr[6] |= UPD_ENABLE | SPAN_MASK;
  nbuf_addr[7] = px_info_ptr->rb_phys | image_off;
  nbuf_addr[8] = 2*span_len*sizeof(int);
  nbuf_addr[9] = xStart << 19 | (ydst << 3);
  nbuf_addr[10] = 0x0;
  
  ga_send_packet();
}
